/*
 *  Filename : MT7segX.c
 *  Author   : Supachai Budsaratij
 *             School of Computer and Advanced Technologies
 *             Rajabhat Institute Phetchaburi
 *  e-mail   : raek@se-ed.org
 *  Date     : March 27,2000
 *  compile  : cc51 MT7segX -pio m=L
 *  Hardware : SILA MTOOL7 V2.0
 */

#define USE_LCD
#define USE_RS232
#define USE_8255

#include <8051io.h>
#include "mtool7.h"

unsigned char enable[6] = {0x01, 0x02, 0x04, 0x08, 0x10, 0x20};

main()
{
    unsigned char count;
    int loops;

    PowerOnReset();
    count = 0;
    LcdCommand(LCD_CLS);
    LcdGoto(0,0); LcdPutS("- Munc5x startup -");

    while(1) {
        i8255Write(i8255PA,0x3F);
        i8255Write(i8255PB,~enable[count]);
        count++;
        if (count == 6) count = 0;
        for (loops = 0; loops < 250; loops++) {
            WatchDogACK();
            i8255Delay();
        }
    }
}
